Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::VertexDeclaration Class Reference

This class declares the format of a set of vertex inputs, which can be issued to the rendering API through a RenderOperation. More...

`#include <OgreHardwareVertexBuffer.h>`

List of all members.

## Public Types
typedef std::list< VertexElement > | VertexElementList
| Defines the list of vertex elements that makes up this declaration.
## Public Member Functions
| VertexDeclaration ()
| Standard constructor, not you should use HardwareBufferManager::createVertexDeclaration.
virtual | ~VertexDeclaration ()
size_t | getElementCount (void)
| Get the number of elements in the declaration.
const VertexElementList & | getElements (void) const
| Gets read-only access to the list of vertex elements.
const VertexElement * | getElement (unsigned short index)
| Get a single element.
void | sort (void)
| Sorts the elements in this list to be compatible with the maximum number of rendering APIs / graphics cards.
void | closeGapsInSource (void)
| Remove any gaps in the source buffer list used by this declaration.
VertexDeclaration * | getAutoOrganisedDeclaration (bool skeletalAnimation, bool vertexAnimation)
| Generates a new VertexDeclaration for optimal usage based on the current vertex declaration, which can be used with VertexData::reorganiseBuffers later if you wish, or simply used as a template.
unsigned short | getMaxSource (void) const
| Gets the indeex of the highest source value referenced by this declaration.
virtual const VertexElement & | addElement (unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)
| Adds a new VertexElement to this declaration.
virtual const VertexElement & | insertElement (unsigned short atPosition, unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)
| Inserts a new VertexElement at a given position in this declaration.
virtual void | removeElement (unsigned short elem_index)
| Remove the element at the given index from this declaration.
virtual void | removeElement (VertexElementSemantic semantic, unsigned short index=0)
| Remove the element with the given semantic and usage index.
virtual void | removeAllElements (void)
| Remove all elements.
virtual void | modifyElement (unsigned short elem_index, unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)
| Modify an element in-place, params as addElement.
virtual const VertexElement * | findElementBySemantic (VertexElementSemantic sem, unsigned short index=0)
| Finds a VertexElement with the given semantic, and index if there is more than one element with the same semantic.
virtual VertexElementList | findElementsBySource (unsigned short source)
| Gets a list of elements which use a given source.
virtual size_t | getVertexSize (unsigned short source)
| Gets the vertex size defined by this declaration for a given source.
virtual VertexDeclaration * | clone (void)
| Clones this declaration.
bool | operator== (const VertexDeclaration &rhs) const
bool | operator!= (const VertexDeclaration &rhs) const
## Static Public Member Functions
static bool | vertexElementLess (const VertexElement &e1, const VertexElement &e2)
| Sort routine for vertex elements.
## Protected Attributes
VertexElementList | mElementList

## Detailed Description

This class declares the format of a set of vertex inputs, which can be issued to the rendering API through a RenderOperation.

Remarks:
  You should be aware that the ordering and structure of the VertexDeclaration can be very important on DirectX with older cards,so if you want to maintain maximum compatibility with all render systems and all cards you should be careful to follow these rules:
  1. VertexElements should be added in the following order, and the order of the elements within a shared buffer should be as follows: position, blending weights, normals, diffuse colours, specular colours, texture coordinates (in order, with no gaps)
  2. You must not have unused gaps in your buffers which are not referenced by any VertexElement
  3. You must not cause the buffer & offset settings of 2 VertexElements to overlap
  Whilst GL and more modern graphics cards in D3D will allow you to defy these rules, sticking to them will ensure that your buffers have the maximum compatibility.

  Like the other classes in this functional area, these declarations should be created and destroyed using the HardwareBufferManager.

Definition at line 291 of file OgreHardwareVertexBuffer.h.

## Member Typedef Documentation

typedef std::list<VertexElement> Ogre::VertexDeclaration::VertexElementList

| Defines the list of vertex elements that makes up this declaration. Definition at line 295 of file OgreHardwareVertexBuffer.h.

## Constructor & Destructor Documentation

Ogre::VertexDeclaration::VertexDeclaration | ( |  | ) |

| Standard constructor, not you should use HardwareBufferManager::createVertexDeclaration.

virtual Ogre::VertexDeclaration::~VertexDeclaration | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual const VertexElement& Ogre::VertexDeclaration::addElement | ( | unsigned short | source,
|  | size_t | offset,
|  | VertexElementType | theType,
|  | VertexElementSemantic | semantic,
|  | unsigned short | index = `0`
| ) | `[virtual]`

  | Adds a new VertexElement to this declaration. Remarks: This method adds a single element (positions, normals etc) to the end of the vertex declaration. Please read the information in VertexDeclaration about the importance of ordering and structure for compatibility with older D3D drivers. Parameters:
  | source | The binding index of HardwareVertexBuffer which will provide the source for this element. See VertexBufferBindingState for full information.
  | offset | The offset in bytes where this element is located in the buffer
  | theType | The data format of the element (3 floats, a colour etc)
  | semantic | The meaning of the data (position, normal, diffuse colour etc)
  | index | Optional index for multi-input elements like texture coordinates
Returns: A reference to the VertexElement added.

virtual VertexDeclaration* Ogre::VertexDeclaration::clone | ( | void |  | ) | `[virtual]`

| Clones this declaration.

void Ogre::VertexDeclaration::closeGapsInSource | ( | void |  | ) |

| Remove any gaps in the source buffer list used by this declaration. Remarks: This is useful if you've modified a declaration and want to remove any gaps in the list of buffers being used. Note, however, that if this declaration is already being used with a VertexBufferBinding, you will need to alter that too. This method is mainly useful when reorganising buffers based on an altered declaration. Note: This will cause the vertex declaration to be re-sorted.

virtual const VertexElement* Ogre::VertexDeclaration::findElementBySemantic | ( | VertexElementSemantic | sem,
|  | unsigned short | index = `0`
| ) | `[virtual]`

| Finds a VertexElement with the given semantic, and index if there is more than one element with the same semantic. Remarks: If the element is not found, this method returns null.

virtual VertexElementList Ogre::VertexDeclaration::findElementsBySource | ( | unsigned short | source | ) | `[virtual]`

| Gets a list of elements which use a given source. Remarks: Note that the list of elements is returned by value therefore is separate from the declaration as soon as this method returns.

VertexDeclaration* Ogre::VertexDeclaration::getAutoOrganisedDeclaration | ( | bool | skeletalAnimation,
|  | bool | vertexAnimation
| ) |

  | Generates a new VertexDeclaration for optimal usage based on the current vertex declaration, which can be used with VertexData::reorganiseBuffers later if you wish, or simply used as a template. Remarks: Different buffer organisations and buffer usages will be returned depending on the parameters passed to this method. Parameters:
  | skeletalAnimation | Whether this vertex data is going to be skeletally animated
  | vertexAnimation | Whether this vertex data is going to be vertex animated

const VertexElement* Ogre::VertexDeclaration::getElement | ( | unsigned short | index | ) |

| Get a single element.

size_t Ogre::VertexDeclaration::getElementCount | ( | void |  | ) |

| Get the number of elements in the declaration. Definition at line 306 of file OgreHardwareVertexBuffer.h.

const VertexElementList& Ogre::VertexDeclaration::getElements | ( | void |  | ) | const

| Gets read-only access to the list of vertex elements.

unsigned short Ogre::VertexDeclaration::getMaxSource | ( | void |  | ) | const

| Gets the indeex of the highest source value referenced by this declaration.

virtual size_t Ogre::VertexDeclaration::getVertexSize | ( | unsigned short | source | ) | `[virtual]`

| Gets the vertex size defined by this declaration for a given source.

virtual const VertexElement& Ogre::VertexDeclaration::insertElement | ( | unsigned short | atPosition,
|  | unsigned short | source,
|  | size_t | offset,
|  | VertexElementType | theType,
|  | VertexElementSemantic | semantic,
|  | unsigned short | index = `0`
| ) | `[virtual]`

  | Inserts a new VertexElement at a given position in this declaration. Remarks: This method adds a single element (positions, normals etc) at a given position in this vertex declaration. Please read the information in VertexDeclaration about the importance of ordering and structure for compatibility with older D3D drivers. Parameters:
  | source | The binding index of HardwareVertexBuffer which will provide the source for this element. See VertexBufferBindingState for full information.
  | offset | The offset in bytes where this element is located in the buffer
  | theType | The data format of the element (3 floats, a colour etc)
  | semantic | The meaning of the data (position, normal, diffuse colour etc)
  | index | Optional index for multi-input elements like texture coordinates
Returns: A reference to the VertexElement added.

virtual void Ogre::VertexDeclaration::modifyElement | ( | unsigned short | elem_index,
|  | unsigned short | source,
|  | size_t | offset,
|  | VertexElementType | theType,
|  | VertexElementSemantic | semantic,
|  | unsigned short | index = `0`
| ) | `[virtual]`

| Modify an element in-place, params as addElement. Remarks: Please read the information in VertexDeclaration about the importance of ordering and structure for compatibility with older D3D drivers.

bool Ogre::VertexDeclaration::operator!= | ( | const VertexDeclaration & | rhs | ) | const

| Definition at line 446 of file OgreHardwareVertexBuffer.h.

bool Ogre::VertexDeclaration::operator== | ( | const VertexDeclaration & | rhs | ) | const

| Definition at line 429 of file OgreHardwareVertexBuffer.h.

virtual void Ogre::VertexDeclaration::removeAllElements | ( | void |  | ) | `[virtual]`

| Remove all elements.

virtual void Ogre::VertexDeclaration::removeElement | ( | VertexElementSemantic | semantic,
|  | unsigned short | index = `0`
| ) | `[virtual]`

| Remove the element with the given semantic and usage index. Remarks: In this case 'index' means the usage index for repeating elements such as texture coordinates. For other elements this will always be 0 and does not refer to the index in the vector.

virtual void Ogre::VertexDeclaration::removeElement | ( | unsigned short | elem_index | ) | `[virtual]`

| Remove the element at the given index from this declaration.

void Ogre::VertexDeclaration::sort | ( | void |  | ) |

| Sorts the elements in this list to be compatible with the maximum number of rendering APIs / graphics cards. Remarks: Older graphics cards require vertex data to be presented in a more rigid way, as defined in the main documentation for this class. As well as the ordering being important, where shared source buffers are used, the declaration must list all the elements for each source in turn.

static bool Ogre::VertexDeclaration::vertexElementLess | ( | const VertexElement & | e1,
|  | const VertexElement & | e2
| ) | `[static]`

| Sort routine for vertex elements.

## Member Data Documentation

VertexElementList Ogre::VertexDeclaration::mElementList`[protected]`

| Definition at line 299 of file OgreHardwareVertexBuffer.h.

The documentation for this class was generated from the following file:

- OgreHardwareVertexBuffer.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:52 2008